import time
import cv2

class init():

    def __init__(self, rtspString):
        # rtspString = "rtsp://sunliteai:1qazXDR%@192.168.1.17:8554/test"
        self.rtspString = rtspString
        self.SHOW_LIVEVIEW = True
        self.SHOW_INFO_IN_TERMINAL = True
        self.SHOW_INFO_IN_LIVEVIEW = True

    def write_text(self, imgRaw, text1, text2):
        # text = "FONT_HERSHEY_DUPLEX"
        position1 = (20, 25)
        position2 = (20, 50)
        font = cv2.FONT_HERSHEY_SIMPLEX
        size1 = 0.6
        size2 = 0.6
        color = (64, 255, 255)
        thickness = 1
        lineType =  cv2.LINE_AA
        cv2.putText(imgRaw, text1, position1, font, size1, color, thickness, lineType)
        cv2.putText(imgRaw, text2, position2, font, size2, color, thickness, lineType)
        return imgRaw

    # purpose: to display the  video streaming
    # imgRatio: the ratio(%) of the original image
    def show_video(self, imgRatio):

        videoID = cv2.VideoCapture(self.rtspString)
        streamingInitTime = time.time()    # streaming initial time
        ttlFrameCt = 0
        beforeTime = 0

        while(True):
            # videoID.read() will return two value:
            #   videoID.read()[0]: True/False (success get the screen or not)
            #   videoID.read()[1]) The image we get from RTSP.
            imgRaw = videoID.read()[1]

            # get the RTSP original image size
            imgRawShape = imgRaw.shape
            # reset the image size(bigger or smaller)
            imgRawShape = (int(imgRawShape[1]*imgRatio), int(imgRawShape[0]*imgRatio))
            # the total image frame already passed
            ttlFrameCt += 1
            # the total elapsed time
            elapsedTime = time.time()-streamingInitTime
            # information string/format: e.g. [.2f]===>78.33 and [08d]===>00001259
            info_text1 = "Time: {:.2f}, Frame count: {:08d}".format(elapsedTime, ttlFrameCt)
            info_text2 = "fps: {:.2f}, fps_one: {:.2f}".format(ttlFrameCt/elapsedTime, 1/(elapsedTime-beforeTime))
            # put the real-time streaming information on the video/images
            if SHOW_INFO_IN_LIVEVIEW:
                imgRaw = write_text(imgRaw, info_text1, info_text2)
            # display the streaming information on terminal/client
            if SHOW_INFO_IN_TERMINAL:
                print(f"\r{info_text1, info_text2, imgRawShape}", end = "")

            beforeTime = time.time()-streamingInitTime
            
            # you can resize the display video size by interpolation=cv2.INTER_CUBIC: the algorithm of image resize
            imgRaw = cv2.resize(imgRaw, imgRawShape, interpolation=cv2.INTER_CUBIC)

            # show the image streaming as a video
            if SHOW_LIVEVIEW:
                imgRaw = cv2.resize(imgRaw, imgRawShape, interpolation=cv2.INTER_CUBIC)
                window_title = 'rtsp streaming display'
                cv2.namedWindow(window_title, cv2.WINDOW_NORMAL)
                cv2.resizeWindow(window_title, imgRawShape[0], imgRawShape[1])
                cv2.imshow(window_title, imgRaw)
                cv2.waitKey(1)
